<?php

namespace Drupal\file_update\Plugin\FileUpdate;

/**
 * Plugin implementation file_update plugins.
 *
 * @FileUpdate(
 *   id = "file",
 *   label = @Translation("File reference field type"),
 *   description = @Translation("Updates fields of type file (core)."),
 *   permission = "administer nodes",
 * )
 */
class FileUpdateFileField extends FileUpdateBase implements FileUpdateInterface {

  /**
   * {@inheritdoc}
   */
  public function isRequired(): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function getUsage(): bool|array {
    $collector = [];
    foreach ($this->getFileReference() as $key => $usage) {
      foreach ($usage as $entity_type => $entities) {
        foreach ($entities as $entity_id => $entity) {
          $collector[] = "$entity_type:$entity_id->$key";
        }
      }
    }
    return $collector;
  }

  /**
   * {@inheritdoc}
   */
  public function updateUri(string $uri): void {
  }

  /**
   * {@inheritdoc}
   */
  public function updateResolution(int $width, int $height): array|bool {
    return TRUE;
  }

}
